diff --git a/modules/sngtc/sngtc.c b/modules/sngtc/sngtc.c
index c9717465e9..591a8449f9 100644
--- a/modules/sngtc/sngtc.c
+++ b/modules/sngtc/sngtc.c
@@ -403,40 +403,32 @@ static void mod_destroy(void)
 static int sng_logger(int level, char *fmt, ...)
 {
 	va_list args;
-	static char buffer[256];
+	char buffer[256];
 
 	va_start(args, fmt);
 
 	vsnprintf(buffer, 256, fmt, args);
 
 	switch (level) {
-	case SNGTC_LOGLEVEL_DEBUG:
-		LM_GEN1(L_DBG, fmt, args);
 		LM_DBG("%s\n", buffer);
 		break;
-	case SNGTC_LOGLEVEL_WARN:
-		LM_GEN1(L_WARN, fmt, args);
-		LM_WARN("%s\n", buffer);
-		break;
+
 	case SNGTC_LOGLEVEL_INFO:
-		LM_GEN1(L_INFO, fmt, args);
-		LM_INFO("%s\n", buffer);
-		break;
 	case SNGTC_LOGLEVEL_STATS:
-		LM_GEN1(L_INFO, fmt, args);
 		LM_INFO("%s\n", buffer);
 		break;
+
+	case SNGTC_LOGLEVEL_WARN:
+		LM_WARN("%s\n", buffer);
+		break;
+
 	case SNGTC_LOGLEVEL_ERROR:
-		LM_GEN1(L_ERR, fmt, args);
 		LM_ERR("%s\n", buffer);
 		break;
-	case SNGTC_LOGLEVEL_CRIT:
-		LM_GEN1(L_CRIT, fmt, args);
-		LM_CRIT("%s\n", buffer);
-		break;
 
+	case SNGTC_LOGLEVEL_CRIT:
 	default:
-		LM_GEN1(L_WARN, fmt, args);
+		LM_CRIT("%s\n", buffer);
 	}
 
 	va_end(args);
@@ -1316,7 +1308,7 @@ static int sngtc_callee_answer(struct sip_msg *msg)
 
 	/* perform all 200 OK SDP changes and pre-compute the ACK SDP body */
 	rc = process_session(msg, info, &caller_sdp, &dst, sdp.sessions,
-	                     msg->sdp->sessions);
+	                     get_sdp(msg)->sessions);
 	if (rc != 0) {
 		LM_ERR("failed to rewrite SDP bodies of the endpoints\n");
 		goto out_free;
@@ -1341,7 +1333,7 @@ static int sngtc_callee_answer(struct sip_msg *msg)
 	lock_release(&info->lock);
 
 	if (sdp.sessions)
-		__free_sdp(&sdp);
+		free_sdp_content(&sdp);
 
 	return 1;
 
@@ -1350,7 +1342,7 @@ static int sngtc_callee_answer(struct sip_msg *msg)
 	lock_release(&info->lock);
 
 	if (sdp.sessions)
-		__free_sdp(&sdp);
+		free_sdp_content(&sdp);
 
 	return rc;
 }
diff --git a/parser/sdp/sdp.c b/parser/sdp/sdp.c
index 3f28d37b4b..05c3caf3f0 100644
--- a/parser/sdp/sdp.c
+++ b/parser/sdp/sdp.c
@@ -601,11 +601,7 @@ sdp_info_t* parse_sdp(struct sip_msg* _m)
 	return ret;
 }
 
-
-/**
- * Free all memory.
- */
-void free_sdp(sdp_info_t* sdp)
+void free_sdp_content(sdp_info_t* sdp)
 {
 	sdp_session_cell_t *session, *l_session;
 	sdp_stream_cell_t *stream, *l_stream;
@@ -636,7 +632,6 @@ void free_sdp(sdp_info_t* sdp)
 		}
 		pkg_free(l_session);
 	}
-	pkg_free(sdp);
 }
 
 void print_sdp_stream(sdp_stream_cell_t *stream, int level)
diff --git a/parser/sdp/sdp.h b/parser/sdp/sdp.h
index 316bf375ee..6efbaca6c8 100644
--- a/parser/sdp/sdp.h
+++ b/parser/sdp/sdp.h
@@ -157,13 +157,20 @@ sdp_payload_attr_t* get_sdp_payload4payload(sdp_stream_cell_t *stream, str *rtp_
  */
 sdp_payload_attr_t* get_sdp_payload4index(sdp_stream_cell_t *stream, int index);
 
+/**
+ * Free all memory associated with parsed structure.
+ */
+void free_sdp_content(sdp_info_t* sdp);
 /**
  * Free all memory associated with parsed structure.
  *
- * Note: this will free up the parsed sdp structure (form PKG_MEM).
+ * Note: this will also pkg_free() the given pointer
  */
-void free_sdp(sdp_info_t* sdp);
-
+static inline void free_sdp(sdp_info_t* sdp)
+{
+	free_sdp_content(sdp);
+	pkg_free(sdp);
+}
 
 /**
  * Print the content of the given sdp_info structure.
